/*
 * Copyright (c) 2005-2007 CodeDroids ApS (http://www.codedroids.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * For further information about CodeDroids ApS, please see the
 * company website: http://www.codedroids.com
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $LastChangedRevision: 117 $
 * $LastChangedDate: 2007-02-20 11:24:48 +0100 (Tue, 20 Feb 2007) $
 * 
 */

package com.codedroids.forms;

import org.w3c.dom.*;


/**
 * Children:<br>
 *   -error<br>
 *   min<br>
 *   max<br>
 */
public abstract class A_RangeValidator extends A_Validator {
	
	private String min;
	private String max;
	
	public A_RangeValidator(Form form) {
		super(form);
	}
	
	public A_RangeValidator(Form form, Node validator) {
		super(form, validator);
	}
 
	//abstract public boolean validate(I_Field field) throws ParseException;

	
	public boolean handleChildNode(Node child, short childType, String childName)
	{
		if(super.handleChildNode(child, childType, childName))
			return true;
		if(childType == Node.ELEMENT_NODE) {
			if (childName.equals(Form.FBTAG_MIN)) {
				setMin(Form.collectText(child));
				return true;
			}
			else if (childName.equals(Form.FBTAG_MAX)) {
				setMax(Form.collectText(child));
				return true;
			}
		}
		return false;
	}
	
	//
	// Accessors
	//
	
	public String getMin() {
		return this.min;
	}
	
	public void setMin(String str) {
		this.min = str;
	}
	
	public String getMax() {
		return this.max;
	}
	
	public void setMax(String str) {
		this.max = str;
	}

	//
	//
	//
	
	public String childrenToXML(String indent) 
	{
		String tmp = super.childrenToXML(indent);
	    if(tmp == null && getMin() == null && getMax()==null)
	    	return null;
		StringBuffer b = new StringBuffer();
		if(tmp != null)
			b.append(tmp);

		if(getMin() != null)
			b.append("\n" + indent + "<"+Form.FBTAG_MIN+">" + getMin() + "</"+Form.FBTAG_MIN+">");
		if(getMax() != null)
			b.append("\n" + indent + "<"+Form.FBTAG_MAX+">" + getMax() + "</"+Form.FBTAG_MAX+">");

 		return b.toString();
	}
}