/*
 * Copyright (c) 2005-2007 CodeDroids ApS (http://www.codedroids.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * For further information about CodeDroids ApS, please see the
 * company website: http://www.codedroids.com
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $LastChangedRevision: 117 $
 * $LastChangedDate: 2007-02-20 11:24:48 +0100 (Tue, 20 Feb 2007) $
 * 
 */

package com.codedroids.forms;

import org.w3c.dom.*;


/**
 * <p>&lt;required&gt;</p>
 * 
 * If value is null or the empty string it returns false, otherwise true.<br>
 * Since most other validators defaults to true where this returns false, this check can be placed
 * either before or after without any problems, though it is logical to perform this check first.
 * 
 * Parameters:<br>
 *   error<br>
 *
 */
public class RequiredValidator extends A_Validator {
	
	public RequiredValidator(Form form) {
		super(form);
	}
	
	public RequiredValidator(Form form, Node node) {
		super(form, node);
	}

	public boolean validate(I_Field field) {
		String val = field.getValue();
		return (val != null && val.length() > 0);
	}
}
