/*
 * Copyright (c) 2005-2007 CodeDroids ApS (http://www.codedroids.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * For further information about CodeDroids ApS, please see the
 * company website: http://www.codedroids.com
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $LastChangedRevision: 177 $
 * $LastChangedDate: 2007-05-07 11:38:46 +0200 (Mon, 07 May 2007) $
 * 
 */

package com.codedroids.forms;

import org.w3c.dom.*;


/**
 * &lt;submitlist&gt;<br>
 *   
 *   This is a bit different since we use the generic input in order to have only one of several buttons to
 *   submit their value (buttons won't allow that). On the other hand input-buttons cannot have both a label and
 *   value, the value is the label. So in order not to have to rely on the label (which could be locale-sensistive)
 *   we use the name field to identify from which option the value for this field must be taken.
 *   Rendering must provide input fields according to this strategy - see the DefaultFieldRender.java
 *   Also requires special treatment when taking values from the parameters - see Form.setFieldValues()
 */
public class SubmitList extends A_SingleValueList {

	public SubmitList(Form form) {
		super(form);
	}
	
	public SubmitList(Form form, Node field) {
		super(form, field);
	}
}
