/*
 * Copyright (c) 2006-2007 CodeDroids ApS (http://www.codedroids.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * For further information about CodeDroids ApS, please see the
 * company website: http://www.codedroids.com
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $LastChangedRevision: 117 $
 * $LastChangedDate: 2007-02-20 11:24:48 +0100 (Tue, 20 Feb 2007) $
 * 
 */

package com.codedroids.oc;

/**
 * OCCache will know to get the actual value by means of this interface if the cached object really is a wrapper.
 *
 */
public interface I_OCCacheElementWrapper {

	/**
	 * <p>Typical implementations will set the value as part of the <code>init()</code> method. 
	 * OCCache only calls this as a part of its own <code>setCacheValue()</code> method which will ensure that the value
	 * is not stale before calling.</p>
	 * 
	 * @param value
	 */
	public void setCacheValue(Object value);
	
	/**
	 * <p>Returns the cached value. OCCache only calls this as a part of its own <code>getCacheValue()</code> method which 
	 * will ensure that the value is not stale before calling.</p>
	 * 
	 * @return
	 */
	public Object getCacheValue();

}
