/*
 * Copyright (c) 2005-2007 CodeDroids ApS (http://www.codedroids.com)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * For further information about CodeDroids ApS, please see the
 * company website: http://www.codedroids.com
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * $LastChangedRevision: 177 $
 * $LastChangedDate: 2007-05-07 11:38:46 +0200 (Mon, 07 May 2007) $
 * 
 */

package com.codedroids.records;

import java.util.List;

abstract public class A_Clause {
	
	public A_Clause() {
		super();
	}
	
	/**
	 * returns the number of parameters this clause uses and toSQL expects to bind in the prepared statement
	 */ 
	abstract public int cardinality();
	/** 
	 *  Returns singular value, use the cardinality to determine if this the method makes sense for the given clause.
	 */
	abstract public Object getValue();
	/** 
	 *  Returns multiple values, use the cardinality to determine if this the method makes sense for the given clause.
	 */
	abstract public List getValues();

	/**
	 * returns the record field associated with the clauses, use the cardinality to determine if this the method makes sense for the given clause.
	 */
	abstract public RecordField getField();
	
	/**
	 * returns the record field associated with the clauses, use the cardinality to determine if this the method makes sense for the given clause.
	 */
	abstract public List getFields();
	
	/**
	 * returns sql for prepared statement (i.e. it does not include the value)
	 */ 
	abstract public String toSQL();
	
	public String toString() {
		return toSQL();
	}
}
